const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const purchases = sequelize.define(
    'purchases',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

purchase_number: {
        type: DataTypes.TEXT,
      
      

      },

items: {
        type: DataTypes.TEXT,
      
      

      },

total: {
        type: DataTypes.DECIMAL,
      
      

      },

date: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  purchases.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity














































//end loop



    db.purchases.belongsTo(db.suppliers, {
      as: 'supplier',
      foreignKey: {
        name: 'supplierId',
      },
      constraints: false,
    });




    db.purchases.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.purchases.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return purchases;
};


